# 
# This program reads the output.txt file generated by the C++ program, 'fd_approx.cpp' and plots the results.
# Tested with Python 3.8.5 on 09 February 2021
# 
# This is a part of teaching materials provided for the course
# "Computational Heat & Fluid Flow (ME 605)" taught at IIT Goa
# during the spring semester of 2021
#

import numpy as np
import matplotlib.pyplot as plt

data = np.loadtxt('output.txt')				# Reads the file output.txt

plt.clf()
plt.plot(data[:,0],data[:,1],label='Backward')		# Plot between zeroth and first columns 
plt.plot(data[:,0],data[:,2],'o',label='Forward')		# Plot between zeroth and second columns 
plt.plot(data[:,0],data[:,3],label='Central')			# Plot between zeroth and third columns 
plt.plot(data[:,0],data[:,4],label='Central 2nd der.')	# Plot between zeroth and fourth columns 
plt.plot(data[:,0],data[:,5],'--',label='1st order')		# Plot between zeroth and fifth columns 
plt.plot(data[:,0],data[:,6],'--',label='2nd order')		# Plot between zeroth and sixth columns 
plt.plot(data[:,0],data[:,7],'o-',label='4th order')		# Plot between zeroth and seventh columns 
plt.xscale('log')						# Ploting in log scale for x-axis
plt.yscale('log')						# Ploting in log scale for y-axis
plt.xlabel('$\Delta x$')
plt.ylabel('Truncation Error')
plt.legend()
plt.savefig('truncation-error_FD.pdf')
plt.show()

# ---------------------------------------------------------------------------------------------------
